Torque2D Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Static Protected Member Functions | List of all members
SceneWindow Class Reference

`#include <SceneWindow.h>`

Inheritance diagram for SceneWindow:

## Classes
struct | CameraView
| Camera View. More...

## Public Types
enum | CameraInterpolationMode { INVALID_INTERPOLATION_MODE, LINEAR, SIGMOID }
| Camera Interpolation Mode. More...
Public Types inherited from GuiControl
enum | horizSizingOptions { horizResizeRight = 0, horizResizeWidth, horizResizeLeft, horizResizeCenter, horizResizeRelative }
enum | vertSizingOptions { vertResizeBottom = 0, vertResizeHeight, vertResizeTop, vertResizeCenter, vertResizeRelative }
Public Types inherited from SimSet
typedef SimObjectList::iterator | iterator
typedef SimObjectList::value_type | value
Public Types inherited from SimObject
enum | WriteFlags { SelectedOnly = BIT(0) }

## Public Member Functions
| SceneWindow ()
virtual | ~SceneWindow ()
virtual bool | onAdd ()
| Called when the object is added to the sim. More...
virtual void | onRemove ()
| Called when this object is removed. More...
virtual void | setScene (Scene *pScene)
| Initialization. More...
virtual void | resetScene (void)
void | setRenderGroups (const U32 groupMask)
void | setRenderLayers (const U32 layerMask)
void | setRenderMasks (const U32 layerMask, const U32 groupMask)
U32 | getRenderLayerMask (void)
U32 | getRenderGroupMask (void)
Scene * | getScene (void) const
| Get scene. More...
void | setLockMouse (bool lockStatus)
| Mouse. More...
bool | getLockMouse (void)
Vector2 | getMousePosition (void)
void | setMousePosition (const Vector2 &mousePosition)
void | setBackgroundColor (const ColorF &backgroundColor)
| Background color. More...
const ColorF & | getBackgroundColor (void) const
void | setUseBackgroundColor (const bool useBackgroundColor)
bool | getUseBackgroundColor (void) const
void | setObjectInputEventFilter (const U32 groupMask, const U32 layerMask, const bool useInvisible=false)
| Input. More...
void | setObjectInputEventGroupFilter (const U32 groupMask)
void | setObjectInputEventLayerFilter (const U32 layerMask)
void | setObjectInputEventInvisibleFilter (const bool useInvisible)
void | setUseWindowInputEvents (const bool inputStatus)
void | setUseObjectInputEvents (const bool inputStatus)
bool | getUseWindowInputEvents (void) const
bool | getUseObjectInputEvents (void) const
void | clearWatchedInputEvents (void)
void | removeFromInputEventPick (SceneObject *pSceneObject)
void | addInputListener (SimObject *pSimObject)
void | removeInputListener (SimObject *pSimObject)
void | windowToScenePoint (const Vector2 &srcPoint, Vector2 &dstPoint) const
| Coordinate Conversion. More...
void | sceneToWindowPoint (const Vector2 &srcPoint, Vector2 &dstPoint) const
void | mount (SceneObject *pSceneObject, const Vector2 &mountOffset, const F32 mountForce, const bool sendToMount, const bool mountAngle)
| Mounting. More...
void | dismount (void)
void | dismountMe (SceneObject *pSceneObject)
void | calculateCameraMount (const F32 elapsedTime)
void | interpolateCameraMount (const F32 timeDelta)
void | setViewLimitOn (const Vector2 &limitMin, const Vector2 &limitMax)
| View Limit. More...
void | setViewLimitOff (void)
bool | isViewLimitOn (void) const
Vector2 | getViewLimitMin (void) const
Vector2 | getViewLimitMax (void) const
void | clampCameraViewLimit (void)
void | zeroCameraTime (void)
| Tick Processing. More...
void | resetTickCameraTime (void)
void | updateTickCameraTime (void)
void | resetTickCameraPosition (void)
virtual void | interpolateTick (F32 delta)
virtual void | processTick ()
virtual void | advanceTime (F32 timeDelta)
virtual void | setCameraPosition (const Vector2 &position)
| Camera,. More...
Vector2 | getCameraPosition (void) const
void | setCameraSize (const Vector2 &size)
Vector2 | getCameraSize (void) const
virtual void | setCameraArea (const RectF &cameraWindow)
RectF | getCameraArea (void) const
void | setCameraZoom (const F32 zoomFactor)
F32 | getCameraZoom (void) const
void | setCameraAngle (const F32 cameraAngle)
F32 | getCameraAngle (void) const
virtual void | setTargetCameraPosition (const Vector2 &position)
| Target Camera. More...
Vector2 | getTargetCameraPosition (void) const
void | setTargetCameraSize (const Vector2 &size)
Vector2 | getTargetCameraSize (void) const
virtual void | setTargetCameraArea (const RectF &cameraWindow)
RectF | getTargetCameraArea (void) const
void | setTargetCameraZoom (const F32 zoomFactor)
F32 | getTargetCameraZoom (void) const
void | setTargetCameraAngle (const F32 cameraAngle)
F32 | getTargetCameraAngle (void) const
void | setCameraInterpolationTime (const F32 interpolationTime)
| Camera Interpolation Time/Mode. More...
void | setCameraInterpolationMode (const CameraInterpolationMode interpolationMode)
void | startCameraMove (const F32 interpolationTime)
| Camera Movement. More...
void | stopCameraMove (void)
void | completeCameraMove (void)
void | undoCameraMove (const F32 interpolationTime)
F32 | interpolate (F32 from, F32 to, F32 delta)
void | updateCamera (void)
Vector2 | getCameraRenderPosition (void)
RectF | getCameraRenderArea (void)
const Vector2 | getCameraWindowScale (void) const
F32 | getCameraInterpolationTime (void)
const CameraView & | getCamera (void) const
const Vector2 & | getCameraShake (void) const
bool | isCameraMounted (void) const
bool | isCameraMoving (void) const
void | startCameraShake (const F32 magnitude, const F32 time)
| Camera Shake. More...
void | stopCameraShake (void)
virtual void | resize (const Point2I &newPosition, const Point2I &newExtent)
| GuiControl. More...
virtual void | onRender (Point2I offset, const RectI &updateRect)
virtual void | onMouseEnter (const GuiEvent &event)
virtual void | onMouseLeave (const GuiEvent &event)
virtual void | onMouseDown (const GuiEvent &event)
virtual void | onMouseUp (const GuiEvent &event)
virtual void | onMouseMove (const GuiEvent &event)
virtual void | onMouseDragged (const GuiEvent &event)
virtual void | onMiddleMouseDown (const GuiEvent &event)
virtual void | onMiddleMouseUp (const GuiEvent &event)
virtual void | onMiddleMouseDragged (const GuiEvent &event)
virtual void | onRightMouseDown (const GuiEvent &event)
virtual void | onRightMouseUp (const GuiEvent &event)
virtual void | onRightMouseDragged (const GuiEvent &event)
virtual bool | onMouseWheelDown (const GuiEvent &event)
virtual bool | onMouseWheelUp (const GuiEvent &event)
void | renderMetricsOverlay (Point2I offset, const RectI &updateRect)
| DECLARE_CONOBJECT (SceneWindow)
| Declare Console Object. More...
Public Member Functions inherited from GuiControl
virtual void | getScrollLineSizes (U32 *rowHeight, U32 *columnWidth)
virtual void | getCursor (GuiCursor *&cursor, bool &showCursor, const GuiEvent &lastGuiEvent)
void | awaken ()
| Called when this control and its children have been wired up. More...
void | sleep ()
| Called when this control is no more. More...
void | preRender ()
| Prerender this control and all its children. More...
virtual bool | onInputEvent (const InputEvent &event)
| General input handler. More...
virtual bool | ControlIsChild (GuiControl *child)
void | setControlProfile (GuiControlProfile *prof)
virtual void | onAction ()
| Occurs when this control performs its "action". More...
void | renderJustifiedText (Point2I offset, Point2I extent, const char *text)
void | inspectPostApply ()
void | inspectPreApply ()
void | setSizing (S32 horz, S32 vert)
void | write (Stream &stream, U32 tabStop, U32 flags)
| Overrides Parent Serialization to allow specific controls to not be saved (Dynamic Controls, etc) More...
bool | getCanSave ()
| Returns boolean specifying if a control can be serialized. More...
void | setCanSave (bool bCanSave)
| Set serialization flag. More...
bool | getCanSaveParent ()
| Returns boolean as to whether any parent of this control has the 'no serialization' flag set. More...
const Point2I & | getPosition ()
| Returns position of the control. More...
const Point2I & | getExtent ()
| Returns extents of the control. More...
const RectI & | getBounds ()
| Returns the bounds of the control. More...
const Point2I & | getMinExtent ()
| Returns minimum size the control can be. More...
const S32 | getLeft ()
| Returns the X position of the control. More...
const S32 | getTop ()
| Returns the Y position of the control. More...
const S32 | getWidth ()
| Returns the width of the control. More...
const S32 | getHeight ()
| Returns the height of the control. More...
virtual void | setVisible (bool value)
bool | isVisible ()
| Returns true if the object is visible. More...
void | setActive (bool value)
bool | isActive ()
| Returns true if this control is active. More...
bool | isAwake ()
| Returns true if this control is awake. More...
void | addObject (SimObject *obj)
void | removeObject (SimObject *obj)
GuiControl * | getParent ()
| Returns the control which owns this one. More...
GuiCanvas * | getRoot ()
Point2I | localToGlobalCoord (const Point2I &src)
Point2I | globalToLocalCoord (const Point2I &src)
virtual void | setPosition (const Point2I &newPosition)
virtual void | setExtent (const Point2I &newExtent)
virtual void | setBounds (const RectI &newBounds)
virtual void | setLeft (S32 newLeft)
virtual void | setTop (S32 newTop)
virtual void | setWidth (S32 newWidth)
virtual void | setHeight (S32 newHeight)
virtual void | childResized (GuiControl *child)
virtual void | parentResized (const Point2I &oldParentExtent, const Point2I &newParentExtent)
virtual bool | renderTooltip (Point2I cursorPos, const char *tipText=NULL)
void | renderChildControls (Point2I offset, const RectI &updateRect)
void | setUpdateRegion (Point2I pos, Point2I ext)
virtual void | setUpdate ()
| Sets the update area of the control to encompass the whole control. More...
virtual bool | onWake ()
| Called when this object is asked to wake up returns true if it's actually awake at the end. More...
virtual void | onSleep ()
| Called when this object is asked to sleep. More...
virtual void | onPreRender ()
| Do special pre-render proecessing. More...
virtual void | onChildRemoved (GuiControl *child)
| Called when one of this objects children is removed. More...
bool | onAdd ()
| Called when this object is added to the scene. More...
virtual void | onChildAdded (GuiControl *child)
| Called when this object has a new child. More...
virtual bool | pointInControl (const Point2I &parentCoordPoint)
bool | cursorInControl ()
| Returns true if the global cursor is inside this control. More...
virtual GuiControl * | findHitControl (const Point2I &pt, S32 initialLayer=-1)
void | mouseLock (GuiControl *lockingControl)
void | mouseLock ()
| Turn on mouse locking with last used lock control. More...
void | mouseUnlock ()
| Unlock the mouse. More...
bool | isMouseLocked ()
| Returns true if the mouse is locked. More...
virtual bool | onMouseDownEditor (const GuiEvent &event, Point2I offset)
virtual bool | onMouseUpEditor (const GuiEvent &event, Point2I offset)
virtual bool | onRightMouseDownEditor (const GuiEvent &event, Point2I offset)
virtual bool | onMouseDraggedEditor (const GuiEvent &event, Point2I offset)
virtual GuiControl * | findFirstTabable ()
| Find the first tab-accessable child of this control. More...
virtual GuiControl * | findLastTabable (bool firstCall=true)
virtual GuiControl * | findPrevTabable (GuiControl *curResponder, bool firstCall=true)
virtual GuiControl * | findNextTabable (GuiControl *curResponder, bool firstCall=true)
virtual void | setFirstResponder (GuiControl *firstResponder)
virtual void | makeFirstResponder (bool value)
bool | isFirstResponder ()
| Returns true if this control is a first responder. More...
virtual void | setFirstResponder ()
| Sets this object to be a first responder. More...
void | clearFirstResponder ()
| Clears the first responder for this chain. More...
GuiControl * | getFirstResponder ()
| Returns the first responder for this chain. More...
virtual void | onLoseFirstResponder ()
| Occurs when the first responder for this chain is lost. More...
void | addAcceleratorKey ()
| Adds the accelerator key for this object to the canvas. More...
virtual void | buildAcceleratorMap ()
virtual void | acceleratorKeyPress (U32 index)
virtual void | acceleratorKeyRelease (U32 index)
virtual bool | onKeyDown (const GuiEvent &event)
virtual bool | onKeyUp (const GuiEvent &event)
virtual bool | onKeyRepeat (const GuiEvent &event)
void | messageSiblings (S32 message)
| Send a message to all siblings. More...
virtual void | onMessage (GuiControl *sender, S32 msg)
virtual void | onDialogPush ()
| Called if this object is a dialog, when it is added to the visible layers. More...
virtual void | onDialogPop ()
| Called if this object is a dialog, when it is removed from the visible layers. More...
void | setConsoleVariable (const char *variable)
void | setConsoleCommand (const char *newCmd)
const char * | getConsoleCommand ()
| Returns the name of the function bound to this GuiControl. More...
LangTable * | getGUILangTable (void)
const UTF8 * | getGUIString (S32 id)
virtual const char * | getScriptValue ()
| Returns the value of the variable bound to this object. More...
virtual void | setScriptValue (const char *value)
| Sets the value of the variable bound to this object. More...
| DECLARE_CONOBJECT (GuiControl)
| GuiControl ()
virtual | ~GuiControl ()
Public Member Functions inherited from SimGroup
| ~SimGroup ()
void | addObject (SimObject *, SimObjectId)
void | addObject (SimObject *, const char *name)
virtual SimObject * | findObject (const char *name)
| Find an object in the group. More...
bool | processArguments (S32 argc, const char **argv)
| Process constructor options. (ie, new SimObject(1,2,3)) More...
| DECLARE_CONOBJECT (SimGroup)
Public Member Functions inherited from SimSet
| SimSet ()
| ~SimSet ()
virtual void | onDeleteNotify (SimObject *object)
virtual U32 | getTamlChildCount (void) const
| Called when Taml attempts to compile a list of children. More...
virtual SimObject * | getTamlChild (const U32 childIndex) const
| Called when Taml attempts to compile a list of children. More...
virtual void | addTamlChild (SimObject *pSimObject)
| Called when Taml attempts to populate an objects children during a read. More...
void | callOnChildren (const char *method, S32 argc, const char *argv[], bool executeOnChildGroups=true)
SimObject * | findObjectByInternalName (const char *internalName, bool searchChildren=false)
virtual bool | writeObject (Stream *stream)
virtual bool | readObject (Stream *stream)
void | lock ()
void | unlock ()
| DECLARE_CONOBJECT (SimSet)
void | _setVectorAssoc (const char *file, const U32 line)
virtual void | pushObject (SimObject *)
virtual void | popObject ()
| Remove an object from the end of the list. More...
void | bringObjectToFront (SimObject *obj)
void | pushObjectToBack (SimObject *obj)
SimObject * | front ()
SimObject * | first ()
SimObject * | last ()
bool | empty ()
S32 | size () const
iterator | begin ()
iterator | end ()
value | operator[] (S32 index)
iterator | find (iterator first, iterator last, SimObject *obj)
iterator | find (SimObject *obj)
template<typename T >
bool | containsType (void)
virtual bool | reOrder (SimObject *obj, SimObject *target=0)
SimObject * | at (S32 index) const
void | deleteObjects (void)
void | clear ()
Public Member Functions inherited from SimObject
StringTableEntry | getClassNamespace () const
StringTableEntry | getSuperClassNamespace () const
void | setClassNamespace (const char *classNamespace)
void | setSuperClassNamespace (const char *superClassNamespace)
void | pushScriptCallbackGuard (void)
void | popScriptCallbackGuard (void)
S32 | getScriptCallbackGuard (void)
Namespace * | getNamespace ()
| Return the object's namespace. More...
const char * | tabComplete (const char *prevText, S32 baseLen, bool)
virtual void | dump ()
virtual void | dumpClassHierarchy ()
SimObject * | clone (const bool copyDynamicFields)
virtual void | copyTo (SimObject *object)
template<typename T >
bool | isType (void)
virtual bool | handlesConsoleMethod (const char *fname, S32 *routingId)
| DECLARE_CONOBJECT (SimObject)
Notify * | removeNotify (void *ptr, Notify::Type)
| Remove a notification from the list. More...
void | deleteNotify (SimObject *obj)
| Notify an object when we are deleted. More...
void | clearNotify (SimObject *obj)
| Notify an object when we are cleared. More...
void | clearAllNotifications ()
| Remove all notifications for this object. More...
void | processDeleteNotifies ()
| Send out deletion notifications. More...
void | registerReference (SimObject **obj)
void | unregisterReference (SimObject **obj)
const char * | getDataField (StringTableEntry slotName, const char *array)
void | setDataField (StringTableEntry slotName, const char *array, const char *value)
const char * | getPrefixedDataField (StringTableEntry fieldName, const char *array)
void | setPrefixedDataField (StringTableEntry fieldName, const char *array, const char *value)
const char * | getPrefixedDynamicDataField (StringTableEntry fieldName, const char *array, const S32 fieldType=-1)
void | setPrefixedDynamicDataField (StringTableEntry fieldName, const char *array, const char *value, const S32 fieldType=-1)
StringTableEntry | getDataFieldPrefix (StringTableEntry fieldName)
U32 | getDataFieldType (StringTableEntry slotName, const char *array)
SimFieldDictionary * | getFieldDictionary ()
void | clearDynamicFields (void)
| Clear all dynamic fields. More...
void | setCanSaveDynamicFields (bool bCanSave)
| Set whether fields created at runtime should be saved. Default is true. More...
bool | getCanSaveDynamicFields (void) const
| Get whether fields created at runtime should be saved. Default is true. More...
void | setInternalName (const char *newname)
StringTableEntry | getInternalName ()
| Get the internal of of this control. More...
virtual bool | save (const char *pcFilePath, bool bOnlySelected=false)
| Save object as a TorqueScript File. More...
virtual bool | isMethod (const char *methodName)
| Check if a method exists in the objects current namespace. More...
SimObjectId | getId (void) const
StringTableEntry | getIdString (void) const
U32 | getType () const
const StringTableEntry | getName (void) const
void | setId (SimObjectId id)
void | assignName (const char *name)
SimGroup * | getGroup () const
bool | isChildOfGroup (SimGroup *pGroup)
bool | isProperlyAdded () const
bool | isDeleted () const
bool | isRemoved () const
bool | isLocked ()
void | setLocked (bool b)
bool | isHidden ()
void | setHidden (bool b)
void | setProgenitorFile (const char *pFile)
StringTableEntry | getProgenitorFile (void) const
void | setPeriodicTimerID (const S32 timerID)
S32 | getPeriodicTimerID (void) const
bool | isPeriodicTimerActive (void) const
bool | isSelected () const
bool | isExpanded () const
void | setSelected (bool sel)
void | setExpanded (bool exp)
void | setModDynamicFields (bool dyn)
void | setModStaticFields (bool sta)
| SimObject ()
virtual | ~SimObject ()
virtual void | onGroupAdd ()
| Called when the object is added to a SimGroup. More...
virtual void | onGroupRemove ()
| Called when the object is removed from a SimGroup. More...
virtual void | onNameChange (const char *name)
| Called when the object's name is changed. More...
virtual void | onStaticModified (const char *slotName, const char *newValue=NULL)
virtual void | onEditorEnable ()
| Called when the editor is activated. More...
virtual void | onEditorDisable ()
| Called when the editor is deactivated. More...
bool | registerObject ()
bool | registerObject (U32 id)
bool | registerObject (const char *name)
bool | registerObject (const char *name, U32 id)
void | unregisterObject ()
void | deleteObject ()
bool | addToSet (SimObjectId)
bool | addToSet (const char *)
bool | removeFromSet (SimObjectId)
bool | removeFromSet (const char *)
virtual bool | writeField (StringTableEntry fieldname, const char *value)
virtual void | writeFields (Stream &stream, U32 tabStop)
virtual void | buildFilterList ()
void | addFieldFilter (const char *fieldName)
void | removeFieldFilter (const char *fieldName)
void | clearFieldFilters ()
bool | isFiltered (const char *fieldName)
void | assignFieldsFrom (SimObject *obj)
void | assignDynamicFieldsFrom (SimObject *obj)
Public Member Functions inherited from ConsoleObject
const AbstractClassRep::Field * | findField (StringTableEntry fieldName) const
| Get a reference to a field by name. More...
virtual AbstractClassRep * | getClassRep () const
| Gets the ClassRep. More...
bool | setField (const char *fieldName, const char *value)
| Set the value of a field. More...
virtual | ~ConsoleObject ()
const AbstractClassRep::FieldList & | getFieldList () const
| Get a list of all the fields. This information cannot be modified. More...
AbstractClassRep::FieldList & | getModifiableFieldList ()
bool & | getDynamicGroupExpand ()
S32 | getClassId (U32 netClassGroup) const
const char * | getClassName () const
Public Member Functions inherited from Tickable
| Tickable ()
virtual | ~Tickable ()
virtual bool | isProcessingTicks () const
virtual void | setProcessTicks (bool tick=true)

## Static Public Member Functions
static void | initPersistFields ()
static CameraInterpolationMode | getInterpolationModeEnum (const char *label)
Static Public Member Functions inherited from GuiControl
static void | initPersistFields ()
Static Public Member Functions inherited from SimObject
static void | initPersistFields ()
Static Public Member Functions inherited from ConsoleObject
static const char * | lookupClassName (const U32 in_classTag)
| Get the classname from a class tag. More...
static void | initPersistFields ()
static void | consoleInit ()
static ConsoleObject * | create (const char *in_pClassName)
static ConsoleObject * | create (const U32 groupId, const U32 typeId, const U32 in_classId)
static AbstractClassRep * | getStaticClassRep ()
| Get the abstract class information for this class. More...
static AbstractClassRep * | getParentStaticClassRep ()
| Get the abstract class information for this class's superclass. More...
Static Public Member Functions inherited from Tickable
static bool | advanceTime (U32 timeDelta)

## Public Attributes
enum SceneWindow::CameraInterpolationMode | mCameraInterpolationMode
Public Attributes inherited from GuiControl
GuiControlProfile * | mProfile
GuiControlProfile * | mTooltipProfile
S32 | mTipHoverTime
S32 | mTooltipWidth
bool | mVisible
bool | mActive
bool | mAwake
bool | mSetFirstResponder
bool | mCanSave
bool | mIsContainer
| if true, then the GuiEditor can drag other controls into this one. More...
S32 | mLayer
RectI | mBounds
Point2I | mMinExtent
StringTableEntry | mLangTableName
LangTable * | mLangTable
SimObjectPtr< GuiControl > | mFirstResponder

## Static Protected Member Functions
static bool | writeLockMouse (void *obj, StringTableEntry pFieldName)
static bool | writeUseWindowInputEvents (void *obj, StringTableEntry pFieldName)
static bool | writeUseObjectInputEvents (void *obj, StringTableEntry pFieldName)
static bool | writeBackgroundColor (void *obj, StringTableEntry pFieldName)
static bool | writeUseBackgroundColor (void *obj, StringTableEntry pFieldName)
Static Protected Member Functions inherited from SimObject
static bool | setClass (void *obj, const char *data)
static bool | setSuperClass (void *obj, const char *data)
static bool | writeCanSaveDynamicFields (void *obj, StringTableEntry pFieldName)
static bool | writeInternalName (void *obj, StringTableEntry pFieldName)
static bool | setParentGroup (void *obj, const char *data)
static bool | writeParentGroup (void *obj, StringTableEntry pFieldName)
static bool | writeSuperclass (void *obj, StringTableEntry pFieldName)
static bool | writeClass (void *obj, StringTableEntry pFieldName)
static SimObject::Notify * | allocNotify ()
| Get a free Notify structure. More...
static void | freeNotify (SimObject::Notify *)
| Mark a Notify structure as free. More...
Static Protected Member Functions inherited from ConsoleObject
static void | addGroup (const char *in_pGroupname, const char *in_pGroupDocs=NULL)
static void | endGroup (const char *in_pGroupname)
static void | addField (const char *in_pFieldname, const U32 in_fieldType, const dsize_t in_fieldOffset, const U32 in_elementCount=1, EnumTable *in_table=NULL, const char *in_pFieldDocs=NULL)
static void | addField (const char *in_pFieldname, const U32 in_fieldType, const dsize_t in_fieldOffset, AbstractClassRep::WriteDataNotify in_writeDataFn, const U32 in_elementCount=1, EnumTable *in_table=NULL, const char *in_pFieldDocs=NULL)
static void | addField (const char *in_pFieldname, const U32 in_fieldType, const dsize_t in_fieldOffset, const char *in_pFieldDocs)
static void | addField (const char *in_pFieldname, const U32 in_fieldType, const dsize_t in_fieldOffset, AbstractClassRep::WriteDataNotify in_writeDataFn, const char *in_pFieldDocs)
static void | addFieldV (const char *in_pFieldname, const U32 in_fieldType, const dsize_t in_fieldOffset, ConsoleTypeValidator *v, const char *in_pFieldDocs=NULL)
static void | addProtectedField (const char *in_pFieldname, const U32 in_fieldType, const dsize_t in_fieldOffset, AbstractClassRep::SetDataNotify in_setDataFn, AbstractClassRep::GetDataNotify in_getDataFn=&defaultProtectedGetFn, const U32 in_elementCount=1, EnumTable *in_table=NULL, const char *in_pFieldDocs=NULL)
static void | addProtectedField (const char *in_pFieldname, const U32 in_fieldType, const dsize_t in_fieldOffset, AbstractClassRep::SetDataNotify in_setDataFn, AbstractClassRep::GetDataNotify in_getDataFn=&defaultProtectedGetFn, AbstractClassRep::WriteDataNotify in_writeDataFn=&defaultProtectedWriteFn, const U32 in_elementCount=1, EnumTable *in_table=NULL, const char *in_pFieldDocs=NULL)
static void | addProtectedField (const char *in_pFieldname, const U32 in_fieldType, const dsize_t in_fieldOffset, AbstractClassRep::SetDataNotify in_setDataFn, AbstractClassRep::GetDataNotify in_getDataFn=&defaultProtectedGetFn, const char *in_pFieldDocs=NULL)
static void | addProtectedField (const char *in_pFieldname, const U32 in_fieldType, const dsize_t in_fieldOffset, AbstractClassRep::SetDataNotify in_setDataFn, AbstractClassRep::GetDataNotify in_getDataFn=&defaultProtectedGetFn, AbstractClassRep::WriteDataNotify in_writeDataFn=&defaultProtectedWriteFn, const char *in_pFieldDocs=NULL)
static void | addDepricatedField (const char *fieldName)
static bool | removeField (const char *in_pFieldname)

## Additional Inherited Members
Static Public Attributes inherited from GuiControl
static GuiEditCtrl * | smEditorHandle = NULL
static S32 | smCursorChanged = -1
| Has this control modified the cursor? -1 or type. More...
static bool | smDesignTime = false
static GuiControl * | smPrevResponder = NULL
static GuiControl * | smCurResponder = NULL
Static Public Attributes inherited from Tickable
static const U32 | smTickShift = 4
| Shift value to control how often Ticks occur. More...
static const U32 | smTickMs = ( 1 << smTickShift )
| Number of milliseconds per tick, 32 in this case. More...
static const F32 | smTickSec = ( F32( Tickable::smTickMs ) / 1000.f )
| Fraction of a second per tick. More...
static const U32 | smTickMask = ( smTickMs - 1 )
Protected Member Functions inherited from GuiControl
const char * | execConsoleCallback ()
| Executes mConsoleCommand, and returns the result. More...
const char * | execAltConsoleCallback ()
| Executes mAltConsoleCommand, and returns the result. More...
void | setVariable (const char *value)
void | setIntVariable (S32 value)
void | setFloatVariable (F32 value)
const char * | getVariable ()
| Returns value of control's bound variable as a string. More...
S32 | getIntVariable ()
| Returns value of control's bound variable as a integer. More...
F32 | getFloatVariable ()
| Returns value of control's bound variable as a float. More...
Protected Member Functions inherited from SimObject
virtual void | onTamlPreWrite (void)
| Taml callbacks. More...
virtual void | onTamlPostWrite (void)
| Called after Taml has finished writing the object. More...
virtual void | onTamlPreRead (void)
| Called prior to Taml reading the object. More...
virtual void | onTamlPostRead (const TamlCustomNodes &customNodes)
virtual void | onTamlAddParent (SimObject *pParentObject)
| Called after Taml has finished reading the object and has added the object to any parent. More...
virtual void | onTamlCustomWrite (TamlCustomNodes &customNodes)
| Called during the writing of the object to allow custom properties to be written. More...
virtual void | onTamlCustomRead (const TamlCustomNodes &customNodes)
| Called during the reading of the object to allow custom properties to be read. More...
void | linkNamespaces ()
void | unlinkNamespaces ()
Protected Member Functions inherited from ConsoleObject
| ConsoleObject ()
| ConsoleObject (const ConsoleObject &)
Protected Attributes inherited from GuiControl
S32 | mHorizSizing
| Set from horizSizingOptions. More...
S32 | mVertSizing
| Set from vertSizingOptions. More...
StringTableEntry | mConsoleVariable
StringTableEntry | mConsoleCommand
StringTableEntry | mAltConsoleCommand
StringTableEntry | mAcceleratorKey
StringTableEntry | mTooltip
Protected Attributes inherited from SimSet
SimObjectList | objectList
void * | mMutex
Protected Attributes inherited from SimObject
SimObjectId | mId
| Id number for this object. More...
StringTableEntry | mIdString
Namespace * | mNameSpace
U32 | mTypeMask
S32 | mScriptCallbackGuard
| Whether the object is executing a script callback. More...
bool | mCanSaveFieldDictionary
| true if dynamic fields (added at runtime) should be saved, defaults to true More...
StringTableEntry | mInternalName
| Stores object Internal Name. More...
StringTableEntry | mClassName
| Stores the class name to link script class namespaces. More...
StringTableEntry | mSuperClassName
| Stores super class name to link script class namespaces. More...
Static Protected Attributes inherited from SimObject
static SimObject::Notify * | mNotifyFreeList = NULL

## Member Enumeration Documentation

enum CameraInterpolationMode

Camera Interpolation Mode.

Enumerator
INVALID_INTERPOLATION_MODE |
LINEAR | Standard Linear.
SIGMOID | Slow Start / Slow Stop.

## Constructor & Destructor Documentation

SceneWindow | ( |  | ) |

~SceneWindow | ( |  | ) |
| virtual

## Member Function Documentation

void addInputListener | ( | SimObject * | pSimObject | ) |

virtual void advanceTime | ( | F32 | timeDelta | ) |
| inline virtual

This method is called once every frame regardless of the return value of isProcessingTicks and informs the object of the passage of time

Implements Tickable.

void calculateCameraMount | ( | const F32 | elapsedTime | ) |

void clampCameraViewLimit | ( | void |  | ) |
| inline

void clearWatchedInputEvents | ( | void |  | ) |
| inline

void completeCameraMove | ( | void |  | ) |

DECLARE_CONOBJECT | ( | SceneWindow |  | ) |

Declare Console Object.

void dismount | ( | void |  | ) |

void dismountMe | ( | SceneObject * | pSceneObject | ) |

const ColorF& getBackgroundColor | ( | void |  | ) | const
| inline

const CameraView& getCamera | ( | void |  | ) | const
| inline

F32 getCameraAngle | ( | void |  | ) | const
| inline

RectF getCameraArea | ( | void |  | ) | const
| inline

F32 getCameraInterpolationTime | ( | void |  | ) |
| inline

Vector2 getCameraPosition | ( | void |  | ) | const
| inline

RectF getCameraRenderArea | ( | void |  | ) |
| inline

Vector2 getCameraRenderPosition | ( | void |  | ) |
| inline

const Vector2& getCameraShake | ( | void |  | ) | const
| inline

Vector2 getCameraSize | ( | void |  | ) | const
| inline

const Vector2 getCameraWindowScale | ( | void |  | ) | const
| inline

F32 getCameraZoom | ( | void |  | ) | const
| inline

SceneWindow::CameraInterpolationMode getInterpolationModeEnum | ( | const char * | label | ) |
| static

bool getLockMouse | ( | void |  | ) |
| inline

Vector2 getMousePosition | ( | void |  | ) |

U32 getRenderGroupMask | ( | void |  | ) |
| inline

U32 getRenderLayerMask | ( | void |  | ) |
| inline

Scene* getScene | ( | void |  | ) | const
| inline

Get scene.

F32 getTargetCameraAngle | ( | void |  | ) | const
| inline

RectF getTargetCameraArea | ( | void |  | ) | const
| inline

Vector2 getTargetCameraPosition | ( | void |  | ) | const
| inline

Vector2 getTargetCameraSize | ( | void |  | ) | const
| inline

F32 getTargetCameraZoom | ( | void |  | ) | const
| inline

bool getUseBackgroundColor | ( | void |  | ) | const
| inline

bool getUseObjectInputEvents | ( | void |  | ) | const
| inline

bool getUseWindowInputEvents | ( | void |  | ) | const
| inline

Vector2 getViewLimitMax | ( | void |  | ) | const
| inline

Vector2 getViewLimitMin | ( | void |  | ) | const
| inline

void initPersistFields | ( |  | ) |
| static

F32 interpolate | ( | F32 | from,
|  | F32 | to,
|  | F32 | delta
| ) |  |

void interpolateCameraMount | ( | const F32 | timeDelta | ) |

void interpolateTick | ( | F32 | delta | ) |
| virtual

This method is called every frame and lets the control interpolate between ticks so you can smooth things as long as isProcessingTicks returns true when it is called on the object

Implements Tickable.

bool isCameraMounted | ( | void |  | ) | const
| inline

bool isCameraMoving | ( | void |  | ) | const
| inline

bool isViewLimitOn | ( | void |  | ) | const
| inline

void mount | ( | SceneObject * | pSceneObject,
|  | const Vector2 & | mountOffset,
|  | const F32 | mountForce,
|  | const bool | sendToMount,
|  | const bool | mountAngle
| ) |  |

Mounting.

bool onAdd | ( | void |  | ) |
| virtual

Called when the object is added to the sim.

Reimplemented from SimObject.

void onMiddleMouseDown | ( | const GuiEvent & | event | ) |
| virtual

Reimplemented from GuiControl.

void onMiddleMouseDragged | ( | const GuiEvent & | event | ) |
| virtual

Reimplemented from GuiControl.

void onMiddleMouseUp | ( | const GuiEvent & | event | ) |
| virtual

Reimplemented from GuiControl.

void onMouseDown | ( | const GuiEvent & | event | ) |
| virtual

Reimplemented from GuiControl.

void onMouseDragged | ( | const GuiEvent & | event | ) |
| virtual

Reimplemented from GuiControl.

void onMouseEnter | ( | const GuiEvent & | event | ) |
| virtual

Reimplemented from GuiControl.

void onMouseLeave | ( | const GuiEvent & | event | ) |
| virtual

Reimplemented from GuiControl.

void onMouseMove | ( | const GuiEvent & | event | ) |
| virtual

Reimplemented from GuiControl.

void onMouseUp | ( | const GuiEvent & | event | ) |
| virtual

Reimplemented from GuiControl.

bool onMouseWheelDown | ( | const GuiEvent & | event | ) |
| virtual

Reimplemented from GuiControl.

bool onMouseWheelUp | ( | const GuiEvent & | event | ) |
| virtual

Reimplemented from GuiControl.

void onRemove | ( |  | ) |
| virtual

Called when this object is removed.

Reimplemented from GuiControl.

void onRender | ( | Point2I | offset,
|  | const RectI & | updateRect
| ) |  |
| virtual

Called when this control is to render itself

Parameters

  offset | The location this control is to begin rendering
  updateRect | The screen area this control has drawing access to

Reimplemented from GuiControl.

void onRightMouseDown | ( | const GuiEvent & | event | ) |
| virtual

Reimplemented from GuiControl.

void onRightMouseDragged | ( | const GuiEvent & | event | ) |
| virtual

Reimplemented from GuiControl.

void onRightMouseUp | ( | const GuiEvent & | event | ) |
| virtual

Reimplemented from GuiControl.

void processTick | ( |  | ) |
| virtual

This method is called once every 32ms if isProcessingTicks returns true when called on the object

Implements Tickable.

void removeFromInputEventPick | ( | SceneObject * | pSceneObject | ) |
| inline

void removeInputListener | ( | SimObject * | pSimObject | ) |

void renderMetricsOverlay | ( | Point2I | offset,
|  | const RectI & | updateRect
| ) |  |

void resetScene | ( | void |  | ) |
| virtual

void resetTickCameraPosition | ( | void |  | ) |

void resetTickCameraTime | ( | void |  | ) |

void resize | ( | const Point2I & | newPosition,
|  | const Point2I & | newExtent
| ) |  |
| virtual

GuiControl.

Reimplemented from GuiControl.

void sceneToWindowPoint | ( | const Vector2 & | srcPoint,
|  | Vector2 & | dstPoint
| ) |  | const

void setBackgroundColor | ( | const ColorF & | backgroundColor | ) |
| inline

Background color.

void setCameraAngle | ( | const F32 | cameraAngle | ) |

void setCameraArea | ( | const RectF & | cameraWindow | ) |
| virtual

void setCameraInterpolationMode | ( | const CameraInterpolationMode | interpolationMode | ) |

void setCameraInterpolationTime | ( | const F32 | interpolationTime | ) |

Camera Interpolation Time/Mode.

void setCameraPosition | ( | const Vector2 & | position | ) |
| virtual

Camera,.

void setCameraSize | ( | const Vector2 & | size | ) |

void setCameraZoom | ( | const F32 | zoomFactor | ) |

void setLockMouse | ( | bool | lockStatus | ) |
| inline

Mouse.

void setMousePosition | ( | const Vector2 & | mousePosition | ) |

void setObjectInputEventFilter | ( | const U32 | groupMask,
|  | const U32 | layerMask,
|  | const bool | useInvisible = `false`
| ) |  |

Input.

void setObjectInputEventGroupFilter | ( | const U32 | groupMask | ) |

void setObjectInputEventInvisibleFilter | ( | const bool | useInvisible | ) |

void setObjectInputEventLayerFilter | ( | const U32 | layerMask | ) |

void setRenderGroups | ( | const U32 | groupMask | ) |
| inline

void setRenderLayers | ( | const U32 | layerMask | ) |
| inline

void setRenderMasks | ( | const U32 | layerMask,
|  | const U32 | groupMask
| ) |  |
| inline

void setScene | ( | Scene * | pScene | ) |
| virtual

Initialization.

void setTargetCameraAngle | ( | const F32 | cameraAngle | ) |

void setTargetCameraArea | ( | const RectF & | cameraWindow | ) |
| virtual

void setTargetCameraPosition | ( | const Vector2 & | position | ) |
| virtual

Target Camera.

void setTargetCameraSize | ( | const Vector2 & | size | ) |

void setTargetCameraZoom | ( | const F32 | zoomFactor | ) |

void setUseBackgroundColor | ( | const bool | useBackgroundColor | ) |
| inline

void setUseObjectInputEvents | ( | const bool | inputStatus | ) |
| inline

void setUseWindowInputEvents | ( | const bool | inputStatus | ) |
| inline

void setViewLimitOff | ( | void |  | ) |
| inline

void setViewLimitOn | ( | const Vector2 & | limitMin,
|  | const Vector2 & | limitMax
| ) |  |

View Limit.

void startCameraMove | ( | const F32 | interpolationTime | ) |

Camera Movement.

void startCameraShake | ( | const F32 | magnitude,
|  | const F32 | time
| ) |  |

Camera Shake.

void stopCameraMove | ( | void |  | ) |

void stopCameraShake | ( | void |  | ) |

void undoCameraMove | ( | const F32 | interpolationTime | ) |

void updateCamera | ( | void |  | ) |

void updateTickCameraTime | ( | void |  | ) |

void windowToScenePoint | ( | const Vector2 & | srcPoint,
|  | Vector2 & | dstPoint
| ) |  | const

Coordinate Conversion.

static bool writeBackgroundColor | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeLockMouse | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeUseBackgroundColor | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeUseObjectInputEvents | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

static bool writeUseWindowInputEvents | ( | void * | obj,
|  | StringTableEntry | pFieldName
| ) |  |
| inline static protected

void zeroCameraTime | ( | void |  | ) |

Tick Processing.

## Member Data Documentation

enum SceneWindow::CameraInterpolationMode mCameraInterpolationMode

The documentation for this class was generated from the following files:

- 2d/gui/SceneWindow.h
- 2d/gui/SceneWindow.cc